package ru.dbotthepony.mc.otm.compat.adastra

import earth.terrarium.ad_astra.AdAstra
import earth.terrarium.ad_astra.common.registry.ModDamageSource
import net.minecraft.world.entity.player.Player
import net.minecraftforge.event.entity.living.LivingHurtEvent
import net.minecraftforge.fml.ModList
import ru.dbotthepony.mc.otm.capability.matteryPlayer
import ru.dbotthepony.mc.otm.config.ServerCompatConfig

val isAdAstraLoaded by lazy {
	ModList.get().isLoaded(AdAstra.MOD_ID)
}

// для надёжности
fun onDamageEvent(event: LivingHurtEvent) {
	check(isAdAstraLoaded) { "Ad Astra is not loaded!" }
	val ply = event.entity as? Player ?: return

	if (ServerCompatConfig.AdAstra.ANDROIDS_DO_NOT_NEED_OXYGEN) {
		if (ply.matteryPlayer?.isAndroid != true) return

		if (event.source === ModDamageSource.OXYGEN) {
			event.amount = 0f
			event.isCanceled = true
		}
	}
}
